SystemOrganization addCategory: #GODCall!

GODData subclass: #GCConference
	instanceVariableNames: 'identifier name acronym edition categories keywords url importantDates venue rating'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCConference class methodsFor: 'spreadsheet' stamp: 'cms 10/18/2014 16:42'!
asSpreadsheet: anCollectionOfConferences
	|spreadsheet sheet|
	spreadsheet := SSSpreadsheetData new.
	sheet := spreadsheet createSheetWithName: 'conferences'.
	
	1 to: (anCollectionOfConferences size) do: [:index |
		"it seems to be generating a infinite loop and squeak ends up crashing, so for now it is commented"
		"sheet createCellAtRow: index atColumn: 'acronym' withValue: (anCollectionOfConferences at: index) acronym.
		sheet createCellAtRow: index atColumn: 'name' withValue: (anCollectionOfConferences at: index) name.
		sheet createCellAtRow: index atColumn: 'categories' withValue: (anCollectionOfConferences at: index) categories.
		sheet createCellAtRow: index atColumn: 'keywords' withValue: (anCollectionOfConferences at: index) keywords.
		sheet createCellAtRow: index atColumn: 'rating' withValue: (anCollectionOfConferences at: index) rating.
		sheet createCellAtRow: index atColumn: 'edition' withValue: (anCollectionOfConferences at: index) edition.
		sheet createCellAtRow: index atColumn: 'url' withValue: (anCollectionOfConferences at: index) url.
		sheet createCellAtRow: index atColumn: 'deadlineDate' withValue: (anCollectionOfConferences at: index) importantDates deadlineDate.
		sheet createCellAtRow: index atColumn: 'startDate' withValue: (anCollectionOfConferences at: index) importantDates endDate.
		sheet createCellAtRow: index atColumn: 'endDate' withValue: (anCollectionOfConferences at: index) importantDates startDate.
		sheet createCellAtRow: index atColumn: 'city' withValue: (anCollectionOfConferences at: index) venue city.
		sheet createCellAtRow: index atColumn: 'country' withValue: (anCollectionOfConferences at: index) venue country.
		sheet createCellAtRow: index atColumn: 'country' withValue: (anCollectionOfConferences at: index) venue place."
	].
	
	^ spreadsheet.	! !

!GCConference class methodsFor: 'spreadsheet' stamp: 'cms 10/18/2014 16:54'!
from: spreadsheet	
	|sheet conferencesCollection conference rows venue importantDates| 
	conferencesCollection := OrderedCollection new.
	
	[	sheet := spreadsheet getSheet: 1. 
		rows := sheet rows.
		rows do: [:row |
 			conference := GCConference new.
			conference acronym: (row getCell: 'acronym').
			conference name: (row getCell: 'name').
			conference name: (row getCell: 'categories').
			conference name: (row getCell: 'keywords').
			conference name: (row getCell: 'rating').
			conference name: (row getCell: 'edition').
			conference name: (row getCell: 'url').
			importantDates := GCImportantDates new.
			importantDates deadlineDate: (row getCell: 'deadlineDate').
			importantDates deadlineDate: (row getCell: 'startDate').
			importantDates deadlineDate: (row getCell: 'endDate').
			venue := GCVenue new.
			venue city: (row getCell: 'city').
			venue country: (row getCell: 'country').
			conference venue: venue.
			conference importantDates: importantDates.	
			conferencesCollection add: conference.     
		].
	^ conferencesCollection.
      ]
	on: Error 
      do: [ ^ conferencesCollection. ].
	
	
! !

!GCConference class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 16:17'!
name: conferenceName acronym: conferenceAcronym url: conferenceUrl what: conferenceCategories when: conferenceImportantDates where: conferenceVenue
	"constructs a GCConference object with all its fields"
	| conference |

	conference := self new.
	conference 	name: conferenceName;
						acronym: conferenceAcronym;
						url: conferenceUrl;
						categories: conferenceCategories;
						importantDates: conferenceImportantDates;
						venue: conferenceVenue.
	^ conference! !

!GCConference class methodsFor: 'normalizing' stamp: 'pfsm 10/16/2014 23:23'!
normalize: aName
	"put aName into normalized form"

	| normalizedName words index |
	
	normalizedName:= String empty.	
	words:= aName findTokens: String space.
	index:=1.

	(aName startsWithDigit)
		ifTrue:[index:=2].

	[index<= words size]
		whileTrue:[ 	normalizedName:= normalizedName,(words at: index).
						 	index:= index+1.
						].

	^(normalizedName onlyLetters) asLowercase.


! !

!GCConference methodsFor: 'comparing' stamp: 'pfsm 10/16/2014 16:59'!
= aConference
	"compare two conferences"
	
	self == aConference ifTrue: [^ true].	"stop recursion"
	(self acronym = aConference acronym) ifFalse: [^ false].
	(self name = aConference name) ifFalse: [^ false].
	(self edition = aConference edition) ifFalse: [^ false].
	(self categories = aConference categories) ifFalse: [^ false].
	((self url) asString  = (aConference url) asString) ifFalse: [^ false].
	(self importantDates = aConference importantDates) ifFalse: [^ false].
	(self venue = aConference venue) ifFalse: [^ false].

^ true.

! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
acronym
	^ acronym! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
acronym: conferenceAcronym
	acronym := conferenceAcronym! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
categories
	^ categories! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
categories: conferenceCategories
	categories := conferenceCategories! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 10/12/2014 22:10'!
edition

	^ edition! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 10/12/2014 22:11'!
edition: anEdition
	"anEdition is usually the year"
	edition := anEdition! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:12'!
identifier

	^ identifier! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
importantDates
	 ^ importantDates! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
importantDates: conferenceImportantDates
	importantDates := conferenceImportantDates! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:12'!
keywords

	^ keywords! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:15'!
keywords: conferenceKeywords

	keywords := conferenceKeywords! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
name
	^ name! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:24'!
name: conferenceName
	name := conferenceName.
	identifier := GCConference normalize: conferenceName.
	! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:12'!
rating

	^ rating! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:15'!
rating: aRating

	rating := aRating! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 16:07'!
url
	^ url! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 16:08'!
url: aUrl

	url:= aUrl! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
venue
	 ^ venue! !

!GCConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
venue: conferenceVenue
	venue := conferenceVenue! !

Object subclass: #GCCrawler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCCrawler class methodsFor: 'initialize' stamp: 'cms 10/11/2014 23:42'!
quallisFileAsSpreadsheet
	"We wait a method from the spreadsheet group to get this input"

	 ^ self notYetImplemented.! !

!GCCrawler class methodsFor: 'initialize' stamp: 'fabcm 10/18/2014 17:19'!
run
		" search for conferences in web, merge information with quallis, and save in database"
	| sourcesCollection spreadsheetCollection spreadsheet mergedSpreadsheet godConferenceCollection|

	sourcesCollection := GCSourceCreator createAll.
	spreadsheetCollection := OrderedCollection new.
   
     	sourcesCollection do: [ :source |
		godConferenceCollection := source crawler crawl: (source categories).
		spreadsheet := GCConference asSpreadsheet: godConferenceCollection.
		spreadsheetCollection add: spreadsheet..
     	].

	"spreadsheet :=  self getQuallisFileAsSpreadsheet."
	"mergedSpreadsheet = GODSpreadsheet  mergeSpreadsheets: spreadsheetCollection."
	mergedSpreadsheet := SSSpreadsheetData new. 

	godConferenceCollection = GCConference from: mergedSpreadsheet.

"	GODDBInput save: godConferenceCollection."
	GCDBFake save: godConferenceCollection.
 	  ^ True.! !

Object subclass: #GCDBFake
	instanceVariableNames: ''
	classVariableNames: 'Collection'
	poolDictionaries: ''
	category: 'GODCall'!

!GCDBFake commentStamp: 'fabcm 10/18/2014 10:11' prior: 0!
GCDBFake no faz parte do projeto.  apenas uma alternativa ao banco de dados, enquanto no temos interface.
!

!GCDBFake class methodsFor: 'as yet unclassified' stamp: 'fabcm 10/18/2014 10:11'!
load
	"Returns the collection saved"
"GCDBFake no faz parte do projeto.  apenas uma alternativa ao banco de dados, enquanto no temos interface."
	
	^ Collection! !

!GCDBFake class methodsFor: 'as yet unclassified' stamp: 'fabcm 10/18/2014 10:12'!
save: aCollection
	"Saves a Collection"
	"GCDBFake no faz parte do projeto.  apenas uma alternativa ao banco de dados, enquanto no temos interface."

	Collection := aCollection! !

Object subclass: #GCImportantDates
	instanceVariableNames: 'startDate endDate deadlineDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCImportantDates class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 16:24'!
from: aStartDate to: anEndDate deadline: aDeadlineDate
	"constructs a GCImportantDates object"
	|importantDates|
	
	importantDates := self new.
	importantDates 	startDate: aStartDate;
							endDate: anEndDate;
							deadlineDate: aDeadlineDate.

	^ importantDates
! !

!GCImportantDates methodsFor: 'comparing' stamp: 'pfsm 10/16/2014 16:30'!
= anImportantDates
	"compare two importantDates"
	
	self == anImportantDates ifTrue: [^ true].	"stop recursion"
	(self startDate = anImportantDates startDate) ifFalse: [^ false].
	(self endDate = anImportantDates endDate) ifFalse: [^ false].
	(self deadlineDate = anImportantDates deadlineDate) ifFalse: [^ false].

^ true.
! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:21'!
deadlineDate
	^ deadlineDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:22'!
deadlineDate: conferenceDeadlineDate
	deadlineDate := conferenceDeadlineDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
endDate
	^ endDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
endDate: conferenceEndDate
	endDate := conferenceEndDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:18'!
startDate
	^ startDate! !

!GCImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
startDate: conferenceStartDate
	startDate := conferenceStartDate! !

Object subclass: #GCRating
	instanceVariableNames: 'qualis hIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCRating methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:10'!
hIndex

	^ hIndex! !

!GCRating methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:10'!
hIndex: anHIndex

	hIndex := anHIndex! !

!GCRating methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:10'!
qualis

	^ qualis! !

!GCRating methodsFor: 'accessing' stamp: 'pfsm 10/16/2014 23:11'!
qualis: aQualis

	qualis := aQualis! !

Object subclass: #GCSearchFilter
	instanceVariableNames: 'searchKey category startDate endDate deadlineDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCSearchFilter class methodsFor: 'initialize' stamp: 'fabcm 10/18/2014 16:41'!
new
	"creates a new object with all fields nil"
	| aSearchFilter |

	aSearchFilter := super new.
	aSearchFilter searchKey: String empty;
						category: #();
						startDate: nil;
						endDate: nil;
						deadlineDate: nil.

	^ aSearchFilter! !

!GCSearchFilter class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 12:02'!
search: aSearchKey in: aCategory from: aStartDate to: anEndDate
	"constructs a new searchFilter with the corresponding arguments "
	|aSearchFilter|

	aSearchFilter := self new.
	aSearchFilter searchKey: aSearchKey;
						category: aCategory;
						startDate: aStartDate;
						endDate: anEndDate.

	 ^  aSearchFilter
		! !

!GCSearchFilter class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 12:05'!
search: aSearchKey in: aCategory from: aStartDate to: anEndDate deadline: aDeadlineDate  
	"constructs a new searchFilter with the corresponding arguments "
	|aSearchFilter|

	aSearchFilter := self new.
	aSearchFilter searchKey: aSearchKey;
						category: aCategory;
						startDate: aStartDate;
						endDate: anEndDate;
						deadlineDate: aDeadlineDate.

	 ^  aSearchFilter
		! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
category

	^ category! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:32'!
category: aCategory
"set category of the conference being searched"
	category := aCategory! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
deadlineDate

	^ deadlineDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:31'!
deadlineDate: aDeadlineDate
"set filter for searching conferences with deadline until aDeadlineDate"
	deadlineDate := aDeadlineDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
endDate

	^ endDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:32'!
endDate: anEndDate
"set filter for searching conferences with end date until anEndDate"
	endDate := anEndDate! !

!GCSearchFilter methodsFor: 'printing' stamp: 'fabcm 10/18/2014 16:37'!
printString
	"Create a string describing the contents stored on search filter"

	| contents |
	
	contents := String empty.
	contents := contents, 'Category: '.
		category do:[ :aCategory | contents := contents, aCategory, ' ' ].
		contents := contents, ' .', String cr.
	contents := contents, 'Deadline Date:: '.
		( deadlineDate = nil ) ifFalse: [ contents := contents, (deadlineDate printFormat: #(1 2 3 $/ 1 1)) asString , ' .'].
		contents := contents , String cr.
	contents := contents, 'Start Date: '.
		( startDate = nil ) ifFalse: [ contents := contents, (startDate printFormat: #(1 2 3 $/ 1 1)) asString, ' .'].
		contents := contents, String cr.
	contents := contents, 'End Date: '.
		( endDate = nil ) ifFalse: [ contents := contents, (endDate printFormat: #(1 2 3 $/ 1 1)) asString , ' .'].
		contents := contents, String cr.
	contents := contents, 'Search Key: ', searchKey, ' .'.
	
	^ contents! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
searchKey

	^ searchKey! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:34'!
searchKey: aSearchKey
"set filter for searching conferences that contain the word aSearchKey"
	searchKey := aSearchKey! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:21'!
startDate

	^ startDate! !

!GCSearchFilter methodsFor: 'accessing' stamp: 'pfsm 9/28/2014 10:35'!
startDate: aStartDate
"set filter for searching conferences with start date after  aStartDate"
	startDate := aStartDate! !

Object subclass: #GCSource
	instanceVariableNames: 'categoryFilepath crawler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCSource methodsFor: 'acessing' stamp: 'cms 10/15/2014 00:30'!
categories
	"returns all categories found in categoryFilepath. Each category must occupy one line in the file"
	|fileData categories|
	fileData := (StandardFileStream fileNamed: categoryFilepath ) contentsOfEntireFile.
	categories:= fileData lines.
	^ categories.! !

!GCSource methodsFor: 'acessing' stamp: 'cms 10/14/2014 23:36'!
categoryFilepath
	 ^ categoryFilepath.! !

!GCSource methodsFor: 'acessing' stamp: 'cms 10/14/2014 23:41'!
categoryFilepath: aFilepath
	"set path to file containing categories of this source"
	categoryFilepath := aFilepath.! !

!GCSource methodsFor: 'acessing' stamp: 'cms 10/15/2014 01:01'!
crawler
	^ crawler.! !

!GCSource methodsFor: 'acessing' stamp: 'cms 10/15/2014 01:01'!
crawler: aCrawler
	crawler := aCrawler.! !

Object subclass: #GCSourceCrawler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

GCSourceCrawler subclass: #GCConfSearchCrawler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCConfSearchCrawler methodsFor: 'perform crawl' stamp: 'cms 10/18/2014 11:53'!
crawl: categories
	"return a collection of GCConferences crawled from searchConf"
	|url pageData|
	categories do: [ :category |
		category := category copyReplaceAll: ' ' with: '%20'.
		"TODO transform this stuff in a constant or attribute"
		url := ('http://confsearch.org/confsearch/faces/pages/topic.jsp?topic=',category) asUrl.
		pageData := WEBWebPageFetcher fetch: url. "Web interface expects input url as String"
		"TODO parse response"
		"TODO add parsed result to GCConferenceCollection"
	].
	^ Array new.! !

!GCConfSearchCrawler methodsFor: 'parsing' stamp: 'cms 10/18/2014 12:23'!
parse: page
	| filter 
	 conferenceCollection 
	 conference importantDates locationString
	 siteCollection siteStart siteEnd 
       acronymCollection acronymStart acronymEnd 
       nameCollection nameStart nameEnd 
       dateCollection dateStart dateEnd 
	 keywordsCollection keywordsStart keywordsEnd
       locationCollection locationStart locationEnd|
	
	siteStart := 'wwwColumn"><a href="'.
	siteEnd := '" target'.
	
	keywordsStart := 'Keywords: '.
	keywordsEnd := '</span&gt;'.

	acronymStart := 'return false;" class="venueAlive">'.
	acronymEnd := '<'.

	nameStart := 'span class="venueAlive venueKeywords">'.
	nameEnd := '<'.

	locationStart := 'td class="locationColumn">'.
	locationEnd := '</td>'.

	dateStart := 'td class="dateColumn">'.
	dateEnd := '</td>'.

	filter := FILTTextFilter new.

	siteCollection := filter filterText: page  between: siteStart  and: siteEnd.

	acronymCollection := filter filterText: page  between: acronymStart and: acronymEnd.

	nameCollection := filter filterText: page  between: nameStart and: nameEnd.

	keywordsCollection := filter filterText: page  between: keywordsStart and: keywordsEnd.

	locationCollection := filter filterText: page  between: locationStart and: locationEnd.

	dateCollection := filter filterText: page  between: dateStart and: dateEnd.

	conferenceCollection := OrderedCollection new.
.
	1 to: acronymCollection size  do: [ :i |
		conference := GCConference new.
		conference acronym: (acronymCollection at: i).
		conference name: (nameCollection at: i).
		conference url: (siteCollection at: i).
		
		locationString := self stripTagsFrom: (locationCollection at: i).
		conference venue: ( self parseVenue: locationString).
		importantDates := GCImportantDates new.

		importantDates deadlineDate: (self stripTagsFrom: (dateCollection at: 4*(i-1) + 1 )).
		importantDates startDate: (self stripTagsFrom: (dateCollection at: (4*(i-1) + 3))).
		importantDates endDate: (self stripTagsFrom: (dateCollection at: (4*(i-1)  + 4))).
		conference importantDates: importantDates.
		conference keywords: ((keywordsCollection at: i) findTokens: ', ').
		conferenceCollection add: conference.
	].
	^ conferenceCollection.

! !

!GCConfSearchCrawler methodsFor: 'parsing' stamp: 'cms 10/18/2014 01:16'!
parseVenue: locationString
	|locationTokens venue|
	locationTokens := locationString findTokens: ','.
	venue := GCVenue new.
	locationTokens size > 0 ifTrue: [
		venue country: (locationTokens at: 1) withBlanksTrimmed.
		locationTokens size > 1 ifTrue: [
			venue city: (locationTokens at: 2) withBlanksTrimmed .
		].
	].
	^ venue.! !

!GCConfSearchCrawler methodsFor: 'parsing' stamp: 'cms 10/16/2014 22:39'!
stripTagsFrom: anString
	^ (anString copyWithRegex: '</.+>'  matchesReplacedWith: '' ) copyWithRegex: '<.+>' matchesReplacedWith: ''.! !

!GCSourceCrawler methodsFor: 'perform crawl' stamp: 'cms 10/15/2014 01:13'!
crawl: categories
	"return a collection of GCConferences crawled from this source"
	^ self subclassResponsibility.! !

GCSourceCrawler subclass: #GCWikiCfpCrawler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCWikiCfpCrawler methodsFor: 'generating urls' stamp: 'pfsm 10/18/2014 19:37'!
conferencesUrlsFrom: categoryUrl
	"explore each page of categoryUrl and extract the conference links in these pages"

	|filter filteredStrings emptyPage pageNumber conferencesUrls categoryStartMark categoryEndMark pageData wikiCfpUrlPrefix|

	filter := FILTTextFilter new.
	filteredStrings := String empty.
	emptyPage := false.
	pageNumber:=1.
	conferencesUrls := Set new.
	wikiCfpUrlPrefix :='http://www.wikicfp.com'.
	categoryStartMark := '<td rowspan="2" align="left"><a href="'.
	categoryEndMark := '">'.

	"this loop fills in conferenceUrls with the links to each conference shown in the webpage pointed by categoryUrl "
	[emptyPage = false]
		whileTrue: [ 	"Web interface expects input url as String"
							pageData := WEBWebPageFetcher fetch: ((categoryUrl asString),'&page=', (pageNumber asString)). 
							filteredStrings := filter filterText: (pageData content) between: categoryStartMark and: categoryEndMark.
							
							(filteredStrings size > 0)
								ifTrue: [	
												filteredStrings do: [:conferenceUrlSuffix | conferencesUrls add: (wikiCfpUrlPrefix,conferenceUrlSuffix) asUrl].
												pageNumber := pageNumber+1.
											]
								ifFalse:[emptyPage := true ].
						].
	

	^ conferencesUrls.! !

!GCWikiCfpCrawler methodsFor: 'perform crawl' stamp: 'pfsm 10/18/2014 19:23'!
crawl: categories
	"return a collection of GCConferences crawled from WikiCFP"
	
	| page categoriesUrls conferencesUrls conferencesList|


	categoriesUrls := self urlsFrom: categories.
	
	conferencesUrls := Set new.
	categoriesUrls do: [ :categoryUrl |	conferencesUrls := conferencesUrls union: (self conferencesUrlsFrom: categoryUrl) ].

	conferencesList := OrderedCollection new.
	conferencesUrls do:[ :confUrl | 	"Web interface expects input url as String"
													page  := WEBWebPageFetcher fetch: (confUrl asString). 
													conferencesList add: (self parse: page).
								].
^ conferencesList.! !

!GCWikiCfpCrawler methodsFor: 'perform crawl' stamp: 'pfsm 10/18/2014 21:28'!
parse: page
	"given a page (html code) of a conference in WikiCFP, this method returns a GCConference object whose its attributes are extracted from  page "

	| filteredStrings acronymAndEditionSMark acronymAndEditionEMark nameSMark nameEMark urlSMark urlEMark startAndDeadlineSMark startAndDeadlineEMark endSMark endEMark cityAndCountrySMark cityAndCountryEMark categoriesSMark categoriesEMark conference conferenceImportantDates conferenceVenue conferenceCategories filter|


	acronymAndEditionSMark :='"dc:title" content="'.
	acronymAndEditionEMark :='">'.
	nameSMark :='"dc:description" content="'.
	nameEMark :='">'.
	urlSMark :='"dc:source" content="'.
	urlEMark :='">'.
	startAndDeadlineSMark :='"v:startDate" content="'.
	startAndDeadlineEMark :='T'.
	endSMark :='"v:endDate" content="'.
	endEMark :='T'.
	cityAndCountrySMark :='"v:locality" content="'.
	cityAndCountryEMark :='">'.
	categoriesSMark:='call?conference='.
	categoriesEMark:='">'.	

	filter := FILTTextFilter new.
	filteredStrings := String empty.
	
	conference := GCConference new.

	filteredStrings := filter filterText: page  between: acronymAndEditionSMark  and: acronymAndEditionEMark.
	filteredStrings := (filteredStrings at:1) findTokens: String space.
	conference acronym: (filteredStrings at:1).
	conference edition: (filteredStrings at:2).

	filteredStrings := filter filterText: page  between: nameSMark and: nameEMark.
	conference name: (filteredStrings at:1).
	
	"filteredStrings := GCSourceCrawlerTest filter: html startMark: urlSMark endMark: urlEMark."
	filteredStrings := filter filterText: page  between: urlSMark and: urlEMark.
	conference url: ((filteredStrings at:1) asUrl).

	conferenceImportantDates := GCImportantDates new.

	filteredStrings := filter filterText: page  between: startAndDeadlineSMark and: startAndDeadlineEMark.
	conferenceImportantDates startDate: ((filteredStrings at:1) asDate).
	conferenceImportantDates deadlineDate: ((filteredStrings at:2) asDate).

	filteredStrings := filter filterText: page  between: endSMark and: endEMark.
	conferenceImportantDates endDate: ((filteredStrings at:1) asDate).

	conferenceVenue := GCVenue new.

	filteredStrings := filter filterText: page  between: cityAndCountrySMark and: cityAndCountryEMark.
	filteredStrings := (filteredStrings at:1) findTokens: ','.
	conferenceVenue city:  (filteredStrings at: 1) withBlanksTrimmed.
	"sometimes there is only the city of the event"
	conferenceVenue country: ((filteredStrings size > 1) 
											ifTrue: [(filteredStrings at: 2) withBlanksTrimmed] 
											ifFalse:[nil]).

	conferenceCategories := Set new.

	filteredStrings := filter filterText: page  between: categoriesSMark and: categoriesEMark.
	filteredStrings do:[:category | conferenceCategories add: ((category copyReplaceAll: '%20' with: String space) asLowercase)].

	conference importantDates: conferenceImportantDates.
	conference venue: conferenceVenue.
	conference categories: conferenceCategories.

^ conference.! !

!GCWikiCfpCrawler methodsFor: 'generating urls' stamp: 'pfsm 10/16/2014 02:22'!
urlsFrom: categories
	"create a WikiCFP url for each category in the list of categories"
	|urls wikiCfpUrlPrefix|

	wikiCfpUrlPrefix := 'http://www.wikicfp.com/cfp/call?conference='. 
	urls := Set new.

	categories do: [ :category |	category := category copyReplaceAll: String space with: '%20'.
											urls add: ((wikiCfpUrlPrefix,category) asUrl).
						].

	^ urls.

! !

Object subclass: #GCSourceCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCSourceCreator class methodsFor: 'create sources' stamp: 'cms 10/14/2014 23:59'!
createAll
	|all|
	all := Bag new.	
	all add: (self createConfSearch).
	all add: (self createWikiCfp).
	^ all.! !

!GCSourceCreator class methodsFor: 'create sources' stamp: 'cms 10/15/2014 01:03'!
createConfSearch
	"creates and returns a instance of GCSource that represents the source WikiCfp"
	|source|
	source := GCSource new.
	source categoryFilepath: '/home/camila/Dropbox/POO 2014/confSearch_categories.txt'.
	source crawler: GCConfSearchCrawler new.
	^ source.
! !

!GCSourceCreator class methodsFor: 'create sources' stamp: 'cms 10/18/2014 11:55'!
createWikiCfp
	"creates and returns a instance of GCSource that represents the source WikiCfp"
	|source|
	source := GCSource new.
	source categoryFilepath: '/home/camila/Dropbox/POO 2014/wikiCfp_categories.txt'.
	source crawler: GCWikiCfpCrawler new.
	^ source.! !

Object subclass: #GCVenue
	instanceVariableNames: 'place city country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GCVenue class methodsFor: 'initialize' stamp: 'pfsm 10/16/2014 15:57'!
city: aCity country: aCountry 
	"constucts a GCVenue object"
	| venue |

	venue:= self new.
	venue	place: nil;
				city: aCity;
				country: aCountry.

	^ venue! !

!GCVenue class methodsFor: 'initialize' stamp: 'pfsm 9/28/2014 16:29'!
place: aPlace city: aCity country: aCountry 
	"constucts a GCVenue object"
	| venue |

	venue:= self new.
	venue	place: aPlace;
				city: aCity;
				country: aCountry.

	^ venue! !

!GCVenue methodsFor: 'comparing' stamp: 'pfsm 10/16/2014 16:25'!
= aVenue
	"compare two venues"
	
	self == aVenue ifTrue: [^ true].	"stop recursion"
	(self place = aVenue place) ifFalse: [^ false].
	(self city = aVenue city) ifFalse: [^ false].
	(self country = aVenue country) ifFalse: [^ false].

^ true.

! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
city
	^ city! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
city: conferenceCity
	city := conferenceCity! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
country
	^ country! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
country: conferenceCountry
	country := conferenceCountry! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
place
	^ place! !

!GCVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:26'!
place: conferencePlace
	place := conferencePlace! !

Object subclass: #GODCall
	instanceVariableNames: 'categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GODCall methodsFor: 'accessing' stamp: 'pfsm 10/12/2014 01:25'!
categories

	^ categories! !

!GODCall methodsFor: 'accessing' stamp: 'pfsm 10/12/2014 01:25'!
categories: anObject

	categories := anObject! !

!GODCall methodsFor: 'initialize' stamp: 'cms 10/5/2014 20:24'!
crawlConferences
   ^ GCCrawler run.     
	! !

!GODCall methodsFor: 'trash' stamp: 'fabcm 10/13/2014 22:44'!
godCallIndexPage
	"THIS METHOD SHOULD BE REMOVED"! !

!GODCall methodsFor: 'initialize' stamp: 'fabcm 10/18/2014 17:35'!
initialize
	"crawlConferences for the first time and register GODCall to Seaside"

	self crawlConferences.
	WEBAppManager register: 'God Call' to: self.! !

!GODCall methodsFor: 'interface' stamp: 'fabcm 10/18/2014 17:01'!
renderContent
	"Create the first page of GodCall with a formulary for the user define his search preferences."

	| page welcome body list filter categoryForm deadlineForm startForm endForm searchForm showFilter submit |

	page := GODData new.
	page layoutGridRowSize: 4 columnSize: 1.

	welcome := GODData new.
	welcome title: 'Welcome to Gods Call!!'.
	welcome content: 'Please, choose below your search preferences'.
	page addOnLayoutGrid: welcome at: 1 at: 1.

	body := GODData new. "body will have a dropdown list together with a inputform associated with the item chosen in the list"
	body layoutGridRowSize: 1 columnSize: 2.
	page addOnLayoutGrid: body at: 2 at: 1.

	filter := GCSearchFilter	new.

	showFilter := GODData new.
	showFilter title: 'Your Search Parameters:'.
	showFilter content: filter printString.
	page addOnLayoutGrid: showFilter at: 3 at: 1.

	submit := WEBInputForm value: 'Click here to search!!' callback: [ :input | ^ self renderOutputPage: (self submitForm: filter). ]. "Here, I just wanted a button..."
	page addOnLayoutGrid: submit at: 4 at: 1.


	categoryForm := WEBInputForm value: 'Category:' callback: [ :input | filter category: input. ].
	deadlineForm := WEBInputForm value: 'Deadline Date (mm/dd/yyyy):' callback: [ :input | filter deadlineDate: (input asDate). ]. 
	"TODO: Maybe in the dates input we need to convert the string to a date..."
	startForm := WEBInputForm value: 'Start Date: (mm/dd/yyyy)' callback: [ :input | filter startDate: (input asDate). ].
	endForm := WEBInputForm value: 'End Date: (mm/dd/yyyy)' callback: [ :input | filter endDate: (input asDate). ].
	searchForm := WEBInputForm value: 'Search Key:' callback: [ :input | filter searchKey: input. ].
	
	list := WEBDropdownList values: #( 'Category' 'Deadline Date' 'Start Date' 'End Date' 'Search Key'  ) 
							   callback: [ :input | ( input = 'Category') ifTrue: [ body addOnLayoutGrid: categoryForm at: 1 at: 2.
																		 	showFilter content: filter printString.].
												( input = 'Deadline Date') ifTrue: [ body addOnLayoutGrid: deadlineForm at: 1 at: 2.
																			 	showFilter content: filter printString.].
												( input = 'Start Date') ifTrue: [ body addOnLayoutGrid: startForm at: 1 at: 2.	
																		     	showFilter content: filter printString.].
												( input = 'End Date') ifTrue: [ body addOnLayoutGrid: endForm at: 1 at: 2.
																		 	showFilter content: filter printString.].
												( input = 'Search Key') ifTrue: [ body addOnLayoutGrid: searchForm at: 1 at: 2.
															 				    showFilter content: filter printString.]. ].
	body addOnLayoutGrid: list at: 1at: 1.

	^ page.! !

!GODCall methodsFor: 'trash' stamp: 'fabcm 10/14/2014 00:26'!
renderOutputPage
	"THIS METHOD SHOULD BE REMOVED"! !

!GODCall methodsFor: 'interface' stamp: 'fabcm 10/16/2014 16:58'!
renderOutputPage: conferencesSpreadsheet
	"Create the output page with the conferences."

	| page title |
	
	page := GODData new.
	page layoutGridRowSize: 2 columnSize: 1.
	
	title := GODData new.
	title content: 'Here are the conferences found:'.
	page addOnLayoutGrid: title at: 1 at: 1.
	
	page addOnLayoutGrid: conferencesSpreadsheet at: 2 at: 1.
	
	^ page.! !

!GODCall methodsFor: 'interface' stamp: 'fabcm 10/18/2014 17:07'!
submitForm: searchFilter
	"executes a user's query defined in the searchFilter and returns a spreadsheet"

	|godConferenceCollection godSpreadsheet|

	"godConferenceCollection :=  GODDBInput getConferences."
	godConferenceCollection := GCDBFake load.	

	godConferenceCollection := FILTConferenceFilter filter: godConferenceCollection byGCSearchFilter: searchFilter.

	godSpreadsheet := GCConference asSpreadsheet: godConferenceCollection.

     ^ godSpreadsheet.! !
